#include "CImageCreater.h"

CImageCreater::CImageCreater()
{

}

bool CImageCreater::WriteBMP(std::string & savePath, unsigned char *rgbbuf, int w, int h, unsigned char * pQR, unsigned char * pQR1)
{
    int size = w * h * 3;

    BITMAPFILEHEADER bmpFileHeader;
    memset(&bmpFileHeader, 0, sizeof(BITMAPFILEHEADER));
    bmpFileHeader.bfSize = size + 54;
    bmpFileHeader.bfOffBits = 54;

    BITMAPINFOHEADER bmpInfoHeader;
    memset(&bmpInfoHeader, 0, sizeof(BITMAPINFOHEADER));
    bmpInfoHeader.biSize = 40;
    bmpInfoHeader.biWidth = w;
    bmpInfoHeader.biHeight = h;
    bmpInfoHeader.biPlanes = 1;
    bmpInfoHeader.biBitCount = 24;

    FILE *bmpfile;
    bmpfile = fopen(savePath.data(), "wb");
    if (!bmpfile) {
        return false;
    }

    fwrite("BM", 1, 2, bmpfile);
    fwrite(&bmpFileHeader, sizeof(BITMAPFILEHEADER), 1, bmpfile);
    fwrite(&bmpInfoHeader, sizeof(BITMAPINFOHEADER), 1, bmpfile);

    int bytesPerLine = w * 3;
    unsigned char * lineData = new unsigned char[bytesPerLine];

    int c = 21;
    int c1 = 33;
    int pix = 10;
    int pix1 = 5;
    int offsetX = 20;
    int offsetY = 20;
    int offsetX1 = 445;
    int offsetY1 = 65;
    int tmpw, tmph, loc;
    unsigned int tmp;
    for(tmph = h - 1; tmph >= 0; tmph--)
    {
        memset(lineData, 0, bytesPerLine);
        for(tmpw = 0; tmpw < w; tmpw++)
        {
            loc = tmph * bytesPerLine + tmpw * 3;
            memcpy(&tmp, rgbbuf + loc, 3);

            if((tmph >= offsetY && tmph < c * pix + offsetY) &&
               (tmpw >= offsetX && tmpw < c * pix + offsetX))
            {
                int m = (tmph - offsetY) / pix;
                int n = (tmpw - offsetX) / pix;
                if(pQR[m * c + n] & 0x01)
                {
                    tmp = 0;
                }
                else
                {
                    tmp = 0xFFFFFF;
                }
            }
            else if((tmph >= offsetY1 && tmph < c1 * pix1 + offsetY1) &&
                    (tmpw >= offsetX1 && tmpw < c1 * pix1 + offsetX1))
             {
                 int m = (tmph - offsetY1) / pix1;
                 int n = (tmpw - offsetX1) / pix1;
                 if(pQR1[m * c1 + n] & 0x01)
                 {
                     tmp = 0;
                 }
                 else
                 {
                     tmp = 0xFFFFFF;
                 }
             }
            lineData[tmpw * 3 + 0] = tmp;
            lineData[tmpw * 3 + 1] = tmp >> 8;
            lineData[tmpw * 3 + 2] = tmp >> 16;

        }
        fwrite(lineData, bytesPerLine, 1, bmpfile);
    }

   fclose(bmpfile);

   delete []lineData;

   return true;

}
