#include <QTextStream>
#include <QPainter>
#include <QThread>
#include <QFile>
#include <QCoreApplication>

#include "CWorkThread.h"
#include "QRLib/qrencode.h"

CWorkThread::CWorkThread(QString srcFile, QObject *parent) :
    QThread(parent),
    m_strSrcPath(srcFile),
    m_bShowCompleted(true)
{
}

void CWorkThread::ShowCompleted()
{
    m_bShowCompleted = true;
}

void CWorkThread::run()
{
    QFile file(m_strSrcPath);
    if(!file.open(QIODevice::ReadOnly | QIODevice::Text))
    {
        onError(tr("0"));
        return ;
    }

    int w = 632;//要4的倍数
    int h = 332;
    unsigned char * pRGB = new unsigned char[w * h * 3];

    std::string dir = QCoreApplication::applicationDirPath().toStdString();
    QTextStream stream(&file);
    QString line, sn, id;
    QStringList list;
    while(!stream.atEnd())
    {
        if(!m_bShowCompleted)
        {
            QThread::msleep(300);
            continue;
        }
        line = stream.readLine();
        //qDebug()<<line;
        list.clear();
        list = line.split(",");
        if(list.size() >= 2)
        {
            sn = list.at(0);
            id = list.at(1);

            QRcode * pQR = QRcode_encodeString(id.toLatin1().data(), 0, QR_ECLEVEL_L, QR_MODE_8, 1);
            if (pQR == NULL) {
                onError(tr("1"));
                return;
            }
            QRcode * pQR1 = QRcode_encodeString("http://a.app.qq.com/o/simple.jsp?pkgname=com.smart.gtstrvl", 0, QR_ECLEVEL_L, QR_MODE_8, 1);
            if (pQR1 == NULL) {
                onError(tr("2"));
                return;
            }

            memset(pRGB, 0xFF, w * h * 3);
            QString out_path1;
            out_path1.sprintf("%s/%04d.bmp", dir.c_str(), sn.toInt());
            qDebug()<<out_path1;
            std::string out_path = out_path1.toStdString(); //QCoreApplication::applicationDirPath().toStdString() + "/" + sn.toStdString() + ".bmp";
            onProcess("正在处理第 " + sn + " 张");

            CImageCreater ic;
            ic.WriteBMP(out_path, pRGB, w, h, pQR->data, pQR1->data);

            //图片上各图片的位置设置
            QImage * img = new QImage;
            if(img->load(out_path.c_str()))
            {
                QPainter painter(img);
                //设置画刷的组合模式CompositionMode_SoutceOut这个模式为目标图像在上
                painter.setCompositionMode(QPainter::CompositionMode_SourceIn);
                //设置画笔（颜色，线宽，样式为实线）
                painter.setPen(QPen(QBrush(Qt::black), 1, Qt::SolidLine));
                //设置线段为反锯齿
                painter.setRenderHint(QPainter::TextAntialiasing, true);
                QFont font = painter.font();
                font.setFamily(tr("Symbol"));
                font.setPixelSize(30);
                font.setBold(false);
                painter.setFont(font);
                int offsetX = 240;
                painter.drawText(offsetX, 90, tr("卡号 ") + id);
                painter.drawText(offsetX, 160, tr("智慧皋亭山"));
                QString tmp;
                tmp.sprintf("SN%04d", sn.toInt());
                painter.drawText(offsetX, 200, tmp);
                painter.drawText(120, 290, tr("官方网站 www.517gts.com"));
                font = painter.font();
                font.setPixelSize(25);
                painter.setFont(font);
                painter.drawText(480, 45, tr("APP下载"));
                img->save(out_path.c_str());

                onCompleted(out_path.c_str());
                m_bShowCompleted = false;
            }
            delete img;

            QRcode_free(pQR);
            QRcode_free(pQR1);

            QThread::msleep(500);
        }
    }
    file.close();
    delete []pRGB;

    return ;
}
