#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <QDebug>
#include <QString>

#include <QFileDialog>

MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);

}

MainWindow::~MainWindow()
{
    delete ui;
}

void MainWindow::onSetImageView(QString path)
{
    QImage * img = new QImage;
    if(img->load(path))
    {
        QPixmap pm = QPixmap::fromImage(*img);
        ui->imgView->setPixmap(pm);

        m_pThread->ShowCompleted();
    }
    delete img;
}

void MainWindow::on_BTSelectFile_clicked()
{
    QString filePath = QFileDialog::getOpenFileName(0, tr("选择数据源"));
    //std::string srcFile = filePath.toLocal8Bit().data();
    ui->EDT_SrcPath->setText(filePath);
    //QString outFilePath = QString::fromLocal8Bit(srcFile.c_str());

    m_pThread = new CWorkThread(filePath);
    connect(m_pThread, SIGNAL(onProcess(QString)), ui->TL_outInfo, SLOT(setText(QString)));
    connect(m_pThread, SIGNAL(onCompleted(QString)), this, SLOT(onSetImageView(QString)));
    connect(m_pThread, SIGNAL(onError(QString)), this, SLOT(onError(QString)));
    m_pThread->start();
}

void MainWindow::onError(QString err)
{
    QMessageBox msgBox(QMessageBox::Warning, tr("提示"), err, 0, this);
    msgBox.addButton(QMessageBox::Ok);
    msgBox.exec();
}
